#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({1, 2}, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("empty vector") {
    double min = 0;
    double max = 0;
    find_minmax({}, min, max);
    CHECK(min == std::numeric_limits<double>::max());
    CHECK(max == std::numeric_limits<double>::lowest());
}

TEST_CASE("single element vector") {
    double min = 0;
    double max = 0;
    find_minmax({42}, min, max);
    CHECK(min == 42);
    CHECK(max == 42);
}

TEST_CASE("negative numbers") {
    double min = 0;
    double max = 0;
    find_minmax({-5, -1, -3}, min, max);
    CHECK(min == -5);
    CHECK(max == -1);
}

TEST_CASE("identical elements") {
    double min = 0;
    double max = 0;
    find_minmax({7, 7, 7}, min, max);
    CHECK(min == 7);
    CHECK(max == 7);
}
//wewger
